unit adt;

interface

uses classes;

Type

TStack = class(TList)
  private
    stacksize : integer;
  public
    procedure init(sz : integer);
    procedure push(p: pointer);
    procedure pop;
    function Top:pointer;
    function empty : Boolean;
    function Full : Boolean;
    function GetStackSize: integer;
  end;

TQueu = class(TList)
  public
    procedure rein(p : pointer);
    procedure raus;
    function vorne:pointer;
    function empty : Boolean;
  end;


implementation

procedure TStack.init(sz : integer);
begin
stacksize := sz;
end;

function TSTack.empty;
begin
  result := (count = 0);
end;

function TStack.Full;
begin
  result := (count = stacksize);
end;

function TStack.GetStackSize: integer;
begin
  result := stacksize;
end;

procedure TStack.push(p: pointer);
begin
if not full then Insert(0,p);
end;


procedure TStack.pop;
begin
if not empty then Delete(0);
end;

function TStack.Top:pointer;
begin
 if not empty then result := Items[0];
end;


procedure TQueu.rein(p : pointer);
begin
add(p);
end;

procedure TQueu.raus;
begin
if not empty then Delete(0);
end;

function TQueu.vorne:pointer;
begin
if not empty then result := Items[0];
end;

function TQueu.empty : Boolean;
begin
  result := (count = 0);
end;


end.
